/*
 * Copyright (c) 2023 - 2024. KeyWare.Co.Ltd All rights reserved.
 * 项目名称：soanr-keyware-example
 * 项目描述：Parent pom of SonarSource public projects
 * 版权说明：本软件属北京关键科技股份有限公司所有，在未获得北京关键科技股份有限公司正式授权情况下，任何企业和个人，不能获取、阅读、安装、传播本软件涉及的任何受知识产权保护的内容。
 */
package com.keyware.sonar;

import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

public class Main {
    public static void main(String[] args) {
        // mvn clean verify sonar:sonar -Dsonar.projectKey=java-test -Dsonar.projectName='java-test' -Dsonar.host.url=http://localhost:9000 -Dsonar.token=sqp_751590ea01a1115ac0c9f10d99fddd2efa09a074
        System.out.printf("Hello and welcome!");
        int ABC = 1;
        for (; ABC <= 5; ABC++) {
            System.out.println("i = " + ABC);
        }
    }

    public void loadLibrary(String libraryName, int number) {
        String abc = "bac";
        System.loadLibrary("/path/to/your/library");
        System.loadLibrary(libraryName); // Noncompliant {{在动态加载库前对输入数据进行验证，确保输入数据仅能用于加载允许加载的代码库}}
    }

    public void  dyan() {
        String regular = "function regular(args1,args2,args3){................}";
        ScriptEngine engine = new ScriptEngineManager().getEngineByName("javascript");
        try {
            engine.eval(regular);  // Noncompliant {{程序设计时禁止动态构建代码进行功能实现}}
            if (engine instanceof Invocable) {
                Invocable invoke = (Invocable) engine;
                String result = (String) invoke.invokeFunction("regular", "");
                System.out.println(result);
            } else {
                System.out.println("error");
            }
        } catch (ScriptException e) {
            System.out.println("表达式runtime错误:" + e.getMessage());
        } catch (NoSuchMethodException e) {
            throw new RuntimeException(e);
        }
    }
}